#!/usr/bin/perl
# list.cgi
# Display the contents of some table

require './shorewall-lib.pl';
&ReadParse();
&can_access($in{'table'}) || &error($text{'list_ecannot'});
&ui_print_header(undef, $text{$in{'table'}."_title"}, "");

$desc = $text{$in{'table'}."_desc"};
print "$desc<p>\n" if ($desc);

$pfunc = $in{'table'}."_parser";
$pfunc = "standard_parser" if (!defined(&$pfunc));
@table = &read_table_file($in{'table'}, $pfunc);
$cfunc = $in{'table'}."_columns";
$cols = &$cfunc() if (defined(&$cfunc));
if (@table) {
	print "<a href='edit.cgi?table=$in{'table'}&new=1'>",
		$text{$in{'table'}."_add"},"</a><br>\n";
	print "<table border>\n";
	print "<tr $tb>\n";
	for($j=0; defined($cols) ? ($j<$cols) : ($text{$in{'table'}."_".$j}); $j++) {
		print "<td><b>",$text{$in{'table'}."_".$j},"</b></td>\n";
		}
	print "<td><b>$text{'list_move'}</b></td>\n" if (@table > 1);
	print "<td><b>$text{'list_add'}</b></td>\n";
	print "</tr>\n";

	$rfunc = $in{'table'}."_row";
	for($i=0; $i<@table; $i++) {
		print "<tr $cb>\n";
		@t = @{$table[$i]};
		if (defined(&$rfunc)) {
			@t = &$rfunc(@t);
			}
		for($j=0; defined($cols) ? ($j<$cols) : ($text{$in{'table'}."_".$j}); $j++) {
			if ($j == 0) {
				print "<td><a href='edit.cgi?table=$in{'table'}&",
				      "idx=$i'>",$t[$j] eq "" ? "<br>" : $t[$j],"</a></td>\n";
				}
			else {
				print "<td>",$t[$j] eq "" ? "<br>" : $t[$j],"</td>\n";
				}
			}
		if (@table > 1) {
			print "<td>\n";
			if ($i == 0) {
				print "<img src=images/gap.gif>";
				}
			else {
				print "<a href='up.cgi?table=$in{'table'}&idx=$i'><img src=images/up.gif border=0></a>\n";
				}
			if ($i == $#table) {
				print "<img src=images/gap.gif>";
				}
			else {
				print "<a href='down.cgi?table=$in{'table'}&idx=$i'><img src=images/down.gif border=0></a>\n";
				}
			print "</td>\n";
			}
		print "<td>";
		print "<a href='edit.cgi?table=$in{'table'}&new=1&before=$i'>",
		      "<img src=images/before.gif border=0></a>\n";
		print "<a href='edit.cgi?table=$in{'table'}&new=1&after=$i'>",
		      "<img src=images/after.gif border=0></a>\n";
		print "</td>\n";
		print "</tr>\n";
		}
	print "</table>\n";
	}
else {
	print "<p><b>",$text{$in{'table'}."_none"},"</b><p>\n";
	}
print "<a href='edit.cgi?table=$in{'table'}&new=1'>",
	$text{$in{'table'}."_add"},"</a><p>\n";

print "<hr>\n";
print &ui_buttons_start();
print &ui_buttons_row("manual_form.cgi", $text{'list_manual'},
		      &text('list_manualdesc',
			"<tt>$config{'config_dir'}/$in{'table'}</tt>"),
		      &ui_hidden("table", $in{'table'}));
print &ui_buttons_end();

&ui_print_footer("", $text{'index_return'});
